<!doctype html>
<!--
    Copyright (c) 2010, 2025 Contributors to the Eclipse Foundation

    See the NOTICE file(s) distributed with this work for additional
    information regarding copyright ownership.

    This program and the accompanying materials are made available under the terms
    of the MIT License which is available at https://opensource.org/licenses/MIT

    SPDX-License-Identifier: MIT
-->
<html lang="en">
    <head>
        <meta charset="utf-8">
        <meta name="viewport" content="width=device-width, initial-scale=1">
        <title>Module 3.2 | SBE Course</title>
        <link rel="icon" type="image/png" href="../sbe-course-favicon.png"/>

        <!-- Bootstrap. -->
        <link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/bootstrap@5.1.1/dist/css/bootstrap.min.css" crossorigin="anonymous">
        <link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/bootstrap-icons@1.6.0/font/bootstrap-icons.css" crossorigin="anonymous">
        <script src="https://cdn.jsdelivr.net/npm/bootstrap@5.1.1/dist/js/bootstrap.bundle.min.js" crossorigin="anonymous"></script>

        <!-- Website styling. -->
        <link rel="stylesheet" href="../../assets/eclipse-escet.css">
        <link rel="stylesheet" href="../../assets/eclipse-escet-sbe-course.css">

        <!-- Version selector. -->
        <script src="../../assets/eclipse-escet.js"></script>

        <!-- Code block syntax highlighting. -->
        <link rel="stylesheet" href="../../assets/styles/asciidoctor-highlightjs-escet.min.css">
        <script src="../../assets/highlight.min.js"></script>
        <script src="../../assets/languages/cif.min.js"></script>
        <script src="../../assets/languages/tooldef.min.js"></script>

        <!-- Quiz. -->
        <link rel="stylesheet" href="../assets/quiz.css">
        <script src="../assets/quiz.js"></script>

        <!-- SBE course. -->
        <link rel="stylesheet" href="../assets/course.css">
        <script src="../assets/course.js"></script>
    </head>

    <body class="escet-dark">

        <!-- Top navigation bar -->
        <nav class="navbar navbar-expand-lg navbar-dark escet-bg">
            <div class="container-fluid">
                <a class="navbar-brand d-lg-none">SBE Course</a>
                <button class="navbar-toggler" type="button" data-bs-toggle="collapse" data-bs-target="#navbarSupportedContent" aria-controls="navbarSupportedContent" aria-expanded="false" aria-label="Toggle navigation">
                    <span class="navbar-toggler-icon"></span>
                </button>
                <div class="collapse navbar-collapse" id="navbarSupportedContent">
                    <ul class="navbar-nav me-auto mb-0 mb-lg-0">
                        <li class="nav-item dropdown">
                            <a class="nav-link dropdown-toggle escet-brand px-0" href="#" id="navbarDropdown" role="button" data-bs-toggle="dropdown" aria-expanded="false">Eclipse ESCET™ / SBE Course</a>
                            <ul class="dropdown-menu" aria-labelledby="navbarDropdown">
                                <li><a class="dropdown-item" href="../.."><img src="../../eclipse-escet-favicon.png" class="pe-2"> Eclipse ESCET / Project</a></li>
                                <li><a class="dropdown-item" href=".."><img src="../sbe-course-favicon.png" class="pe-2"> Eclipse ESCET / SBE Course</a></li>
                                <li><a class="dropdown-item" href="../../cif"><img src="../../cif/cif-favicon.png" class="pe-2"> Eclipse ESCET / CIF</a></li>
                                <li><a class="dropdown-item" href="../../chi"><img src="../../chi/chi-favicon.png" class="pe-2"> Eclipse ESCET / Chi</a></li>
                                <li><a class="dropdown-item" href="../../tooldef"><img src="../../tooldef/tooldef-favicon.png" class="pe-2"> Eclipse ESCET / ToolDef</a></li>
                            </ul>
                        </li>
                        <li class="nav-item">
                            <a class="nav-link" href="../" aria-expanded="false">Home</a>
                        </li>
                        <li class="nav-item dropdown">
                            <a class="nav-link dropdown-toggle" href="#" id="navbarDropdown1" role="button" data-bs-toggle="dropdown" aria-expanded="false">Module 1</a>
                            <ul class="dropdown-menu" aria-labelledby="navbarDropdown1">
                                <li><a class="dropdown-item" href="../module1">Module 1: Supervisory control of discrete event systems</a></li>
                                <li><a class="dropdown-item" href="../module1/supervisory-control.html">Module 1.1: Supervisory control</a></li>
                                <li><a class="dropdown-item" href="../module1/discrete-event-systems.html">Module 1.2: Discrete event systems</a></li>
                                <li><a class="dropdown-item" href="../module1/modeling-discrete-event-systems.html">Module 1.3: Modeling discrete event systems</a></li>
                                <li><a class="dropdown-item" href="../module1/get-started-with-cif.html">Module 1.4: Get started with CIF</a></li>
                                <li><a class="dropdown-item" href="../module1/exercises.html">Module 1.5: Exercises</a></li>
                                <li><a class="dropdown-item" href="../module1/introduction-to-the-water-lock-case.html">Module 1.6: Introduction to the water lock case</a></li>
                            </ul>
                        </li>
                        <li class="nav-item dropdown">
                            <a class="nav-link dropdown-toggle" href="#" id="navbarDropdown2" role="button" data-bs-toggle="dropdown" aria-expanded="false">Module 2</a>
                            <ul class="dropdown-menu" aria-labelledby="navbarDropdown2">
                                <li><a class="dropdown-item" href="../module2">Module 2: Working with automata</a></li>
                                <li><a class="dropdown-item" href="../module2/reachability-deadlock-blocking-livelock.html">Module 2.1: Reachability, deadlock, blocking and livelock</a></li>
                                <li><a class="dropdown-item" href="../module2/non-deterministic-automata.html">Module 2.2: Non-deterministic automata</a></li>
                                <li><a class="dropdown-item" href="../module2/synchronizing-automata.html">Module 2.3: Synchronizing automata</a></li>
                                <li><a class="dropdown-item" href="../module2/shared-variables.html">Module 2.4: Shared variables</a></li>
                                <li><a class="dropdown-item" href="../module2/computing-state-spaces.html">Module 2.5: Computing state spaces</a></li>
                                <li><a class="dropdown-item" href="../module2/cif-tools-view-analyze-models.html">Module 2.6: CIF tools to view and analyze models</a></li>
                                <li><a class="dropdown-item" href="../module2/constants-and-algebraic-variables.html">Module 2.7: Constants and algebraic variables</a></li>
                                <li><a class="dropdown-item" href="../module2/exercises.html">Module 2.8: Exercises</a></li>
                                <li><a class="dropdown-item" href="../module2/more-detailed-models-water-lock-case.html">Module 2.9: More detailed models for the water lock case</a></li>
                            </ul>
                        </li>
                        <li class="nav-item dropdown">
                            <a class="nav-link dropdown-toggle active" aria-current="page" href="#" id="navbarDropdown3" role="button" data-bs-toggle="dropdown" aria-expanded="false">Module 3</a>
                            <ul class="dropdown-menu" aria-labelledby="navbarDropdown3">
                                <li><a class="dropdown-item" href="./">Module 3: Supervisory control and plant models</a></li>
                                <li><a class="dropdown-item" href="supervisory-control-loop.html">Module 3.1: Supervisory control loop</a></li>
                                <li><a class="dropdown-item active" aria-current="page" href="synthesis-guarantees.html">Module 3.2: Synthesis guarantees</a></li>
                                <li><a class="dropdown-item" href="supervisory-controller-synthesis.html">Module 3.3: Supervisory controller synthesis</a></li>
                                <li><a class="dropdown-item" href="modeling-larger-systems.html">Module 3.4: Modeling larger systems</a></li>
                                <li><a class="dropdown-item" href="exercises.html">Module 3.5: Exercises</a></li>
                                <li><a class="dropdown-item" href="water-lock-case-plant-models.html">Module 3.6: Water lock case plant models</a></li>
                            </ul>
                        </li>
                        <li class="nav-item dropdown">
                            <a class="nav-link dropdown-toggle" href="#" id="navbarDropdown4" role="button" data-bs-toggle="dropdown" aria-expanded="false">Module 4</a>
                            <ul class="dropdown-menu" aria-labelledby="navbarDropdown4">
                                <li><a class="dropdown-item" href="../module4">Module 4: Modeling requirements and supervisor synthesis</a></li>
                                <li><a class="dropdown-item" href="../module4/user-specified-requirements.html">Module 4.1: User-specified requirements</a></li>
                                <li><a class="dropdown-item" href="../module4/requirement-automata-and-invariants.html">Module 4.2: Requirements automata and invariants</a></li>
                                <li><a class="dropdown-item" href="../module4/synthesis-with-requirements.html">Module 4.3: Synthesis with requirements</a></li>
                                <li><a class="dropdown-item" href="../module4/modeling-for-synthesis.html">Module 4.4: Modeling for synthesis</a></li>
                                <li><a class="dropdown-item" href="../module4/performing-synthesis-with-cif.html">Module 4.5: Performing synthesis with CIF</a></li>
                                <li><a class="dropdown-item" href="../module4/introduction-to-svg-visualization.html">Module 4.6: Introduction to SVG visualization</a></li>
                                <li><a class="dropdown-item" href="../module4/exercises.html">Module 4.7: Exercises</a></li>
                                <li><a class="dropdown-item" href="../module4/water-lock-case-requirements-and-supervisor.html">Module 4.8: Water lock case requirements and supervisor</a></li>
                            </ul>
                        </li>
                        <li class="nav-item dropdown">
                            <a class="nav-link dropdown-toggle" href="#" id="navbarDropdown5" role="button" data-bs-toggle="dropdown" aria-expanded="false">Module 5</a>
                            <ul class="dropdown-menu" aria-labelledby="navbarDropdown5">
                                <li><a class="dropdown-item" href="../module5">Module 5: Hybrid simulation models</a></li>
                                <li><a class="dropdown-item" href="../module5/timed-and-hybrid-models.html">Module 5.1: Timed and hybrid models</a></li>
                                <li><a class="dropdown-item" href="../module5/variable-time.html">Module 5.2: Variable 'time'</a></li>
                                <li><a class="dropdown-item" href="../module5/continuous-variables.html">Module 5.3: Continuous variables</a></li>
                                <li><a class="dropdown-item" href="../module5/urgency.html">Module 5.4: Urgency</a></li>
                                <li><a class="dropdown-item" href="../module5/tau-event.html">Module 5.5: The 'tau' event</a></li>
                                <li><a class="dropdown-item" href="../module5/exercises.html">Module 5.6: Exercises</a></li>
                                <li><a class="dropdown-item" href="../module5/water-lock-case-hybrid-model.html">Module 5.7: Water lock case hybrid model</a></li>
                                <li><a class="dropdown-item" href="../module5/course-conclusion.html">Module 5.8: Course conclusion</a></li>
                            </ul>
                        </li>
                    </ul>
                </div>
            </div>
        </nav>

        <!-- Intro -->
        <div id="intro" class="position-relative p-3 text-center escet-bg escet-bg-opacity-125">
            <div class="clearfix mb-4 mb-md-0">
                <span class="float-end">
                    Version:
                    <div class="dropdown d-inline-block">
                        <a class="dropdown-toggle" href="#" role="button" id="versionDropdown" data-bs-toggle="dropdown" aria-expanded="false">nightly-20250306-101218</a>
                        <ul id="versions-dropdown" class="dropdown-menu dropdown-menu-end" aria-labelledby="versionDropdown" data-this-version="/nightly">
                            <li><h6 id="versions-previews" class="dropdown-header">Previews</h6></li>
                            <li><h6 id="versions-latest-releases" class="dropdown-header">Latest releases</h6></li>
                            <li><h6 class="dropdown-header">Other</h6></li>
                            <li><a class="dropdown-item" href="../../versions.html">All versions...</a></li>
                        </ul>
                    </div>
                    <a class="text-nowrap ms-3" href="../../release-notes.html">[release notes]</a>
                </span>
            </div>
        </div>

        <!-- Content -->
        <div class="px-4 pt-5">
            <div class="row justify-content-center">
                <div class="col-12 col-md-10 col-xl-8 col-xxl-6" id="content">

                    <h1>Module 3.2: Synthesis guarantees</h1>
                    <p>
                        Supervisory controller synthesis can be used to automatically synthesize a supervisor model from a model of the uncontrolled system and some additional requirements.
                        The theory behind supervisory controller synthesis gives us several guarantees about the synthesized supervisor, namely that the controlled system (the plant combined with the supervisor) satisfies four properties.
                        And we may refer to such a synthesized supervisor controlling the plant as also satisfying these properties.
                        The four properties are: <em>safety</em>, <em>controllability</em>, <em>non-blockingness</em> and <em>maximal permissiveness</em>.
                        The safety guarantee means that the controlled system is safe, in that it adheres to all user-provided requirements, which is covered in Module 4.
                        Here, we will look at the controllability, non-blockingness and maximal-permissiveness guarantees in a bit more detail.
                    </p>

                    <h2 id="controllability">Controllability</h2>
                    <p>
                        In the supervisory control loop a supervisor restricts certain events of the plant from occurring in a controlled system.
                        Controllability is about which events a supervisor can control, and which it can't.
                        The guarantee of controllability then states that, compared to the plant behavior, a synthesized supervisor will never restrict the occurrence of events that it can't control.
                    </p>
                    <p>
                        To make it clear which events a supervisor can control, and which it can't, there are two kinds of events in supervisory control: <em>controllable</em> events and <em>uncontrollable</em> events.
                        A supervisory controller may restrict when controllable events are allowed to occur, but may not restrict the occurrence of uncontrollable events.
                        All events of a system are therefore labeled as being either controllable or uncontrollable.
                    </p>
                    <p>
                        As a simple example, consider a machine with a button and a motor.
                        Pushing the button starts the motor, and releasing the button stops the motor.
                        This system could be modeled as follows, with the top two automata being the plant and the bottom automaton being the supervisor:
                    </p>
                    <img src="images/controllability-example1.png">
                    <p>
                        The top-left automaton models the button.
                        It is a sensor that indicates whether the operator is pushing the button or not.
                        Initially, the button is <em>Released</em>.
                        When the operator pushes the button, it is becomes <em>Pushed</em>.
                        When the operator releases the button, it becomes <em>Released</em> again.
                    <p>
                    <p>
                        The top-right automaton models the motor.
                        Initially, the motor is <em>Off</em>.
                        Once it is turned on, it becomes <em>On</em>.
                        Once it is turned off, it becomes <em>Off</em>.
                    </p>
                    <p>
                        The bottom automaton models the interactions between the button and the motor.
                        It determines, based on the state of the button, what may happen with the motor.
                        The automaton is a copy of the button automaton, with some extra self-loop edges.
                        In the location where the button is <em>Pushed</em>, the motor may be turned on.
                        In the location where the button is <em>Release</em>, the motor may be turned off.
                    </p>
                    <p>
                        Through synchronization, all three automata together model the correct operation of the system.
                        For instance, without the bottom automaton, the motor can be turned on and off at any time, without any relation to the button.
                        And even though the top-right automaton allows a motor to be turned on repeatedly, the bottom automaton indicates this is not possible, as a motor can only alternatingly be turned on and off.
                        The behavior of the top-left automaton is contained in the behavior of the bottom automaton, and could be removed without changing the behavior of this system.
                        We will see later in the course why it is still good to model each part of a system separately, and only then restrict their combined behavior.
                    </p>
                    <p>
                        You may have already observed that some of the edges are depicted as <em>solid</em> arrows, while others are depicted as <em>dashed</em> arrows.
                        The dashed arrows are edges with uncontrollable events.
                        In this case, the button events are uncontrollable events.
                        The operator can always push or release the button.
                        The supervisor can't prevent this.
                        The supervisor must never restrict these events from occurring, as it can't physically prevent the operator from pushing or releasing the button.
                    </p>
                    <p>
                        The motor however, is fully under the control of the supervisor.
                        The supervisor can and should decide when it is allowed to allow turn it on or off.
                        The events to turn the motor on or off are therefore controllable events, indicated by solid arrows.
                    </p>
                    <p>
                        While it is not done in this simple example, a supervisor could for instance disable turning on the motor if somebody is near the machine, to prevent injuries.
                        It could do so, even if the operator pushes the button.
                        This would of course require adding an extra sensor to the system, to detect a person approaching the machine.
                    </p>
                    <p>
                        In general, for supervisory controllers that interact directly with hardware components, actuators are generally modeled as controllable events, while sensors are generally modeled as uncontrollable events.
                        For higher-level supervisory controllers that control sub-systems, the signals the controller gets from the sub-systems are generally modeled as uncontrollable events, and the commands it gives to the sub-systems are generally modeled as controllable events.
                        A supervisor may disable controllable events, but may never disable uncontrollable events.
                        It is up to the modeler to decide for each event whether it is controllable or uncontrollable.
                    </p>
                    <p>
                        And that brings us back to the guarantee of controllability.
                        A synthesized supervisor is guaranteed to be controllable, meaning that it in the controlled system it only disables controllable events, but never uncontrollable ones.
                        A supervisor is thus free to enable or disable controllable events whenever it deems appropriate.
                        But, for any state that is reachable in the controlled system, if in the same state in the uncontrolled system an uncontrollable event is possible, then the event must also be possible in the controlled system.
                    </p>

                    <h2>Modeling controllable and uncontrollable events in CIF</h2>
                    <p>
                        When modeling for supervisory controller synthesis, the events in a CIF model need be distinguished as being controllable or uncontrollable.
                        The <code>event</code> keyword can be replaced by <code>controllable</code> to indicate that the declared events are controllable events, or by <code>uncontrollable</code> to indicate that they are uncontrollable events.
                        Instead of <code>controllable</code> it is also allowed to write <code>controllable event</code>, and similarly for <code>uncontrollable event</code> instead of <code>uncontrollable</code>.
                    </p>
                    <p>
                        In CIF, it is customary to give controllable events a name that starts with <code>c_</code> and uncontrollable events a name that starts with <code>u_</code>.
                        If you follow this convention, then the controllable and uncontrollable events get a different color, making it easier to distinguish them.
                    </p>
                    <p>
                        For instance, some controllable and uncontrollable events could be declared in CIF as follows:
                    </p>
                    <pre class="highlightjs highlight">
                        <code class="language-cif hljs" data-lang="cif">
                            controllable c_start, c_stop;
                            uncontrollable u_pushed, u_released;
                        </code>
                    </pre>

                    <h2>Quiz</h2>
                    <div class="quiz">
                        [
                            {
                                type: 'single-choice',
                                question: "What is the difference between controllable and uncontrollable events?",
                                answers: [
                                    "A supervisor may disable controllable events, but not uncontrollable ones.",
                                    "A supervisor may disable uncontrollable events, but not controllable ones.",
                                    "Uncontrollable events are always associated with sensors and controllable events with actuators.",
                                    "Controllable events are always associated with sensors and uncontrollable events with actuators."
                                ],
                                correctAnswer: '1'
                            },
                            {
                                type: 'multiple-choice',
                                question: `
                                    Consider again the example of a car, with a driver and mechanic, from a <a href="../module2/synchronizing-automata.html">previous module</a>.
                                    Which of the four events of that model would you consider to be uncontrollable?
                                `,
                                answers: [
                                    "Event <code>breakdown</code>.",
                                    "Event <code>call_mechanic</code>.",
                                    "Event <code>repair_finished</code>.",
                                    "Event <code>start_repair</code>."
                                ],
                                correctAnswer: '1'
                            },
                            {
                                type: 'single-choice',
                                question: `
                                    Consider a system with a plant automaton and a supervisor automaton.
                                    The initial location of the plant has two outgoing edges, one with controllable event <code>a</code> and one with uncontrollable event <code>b</code>.
                                    The supervisor's initial location has only one outgoing edge with event <code>a</code>, leading to the second location.
                                    The second location of the supervisor has two outgoing edges with events <code>a</code> and <code>b</code>.
                                    Is this controlled system controllable?
                                    Hint: Try to draw the situation.
                                `,
                                answers: [
                                    "Yes, because the supervisor controls the plant by synchronizing with it.",
                                    "No, because when the automata are in their initial locations, the supervisor has no edge for <code>b</code>, meaning it disables an uncontrolled event that is possible in the plant.",
                                    "Yes, because the alphabets of both automata are the same, which through synchronized events sometimes leads to events getting disabled, without affecting controllability."
                                ],
                                correctAnswer: '2'
                            },
                            {
                                type: 'single-choice',
                                question: `
                                    Consider an alternative button/motor system, where a first push of the button turns on the motor, a second push turns it off, a third push turns it on again, and so on.
                                    The following automata can be used to model this.
                                    If we consider the top two automata as the plant and the bottom one as the supervisor, then this system is controllable.
                                    But, we may wonder whether the two curved edges with event <code>push</code> in the bottom automaton are really needed.
                                    Would the system still be controllable if the two edges would be removed?
                                    Hint: Consider the state spaces of the uncontrolled system and controlled system, their corresponding states, and which uncontrollable events are enabled in corresponding states.
                                    <img src="images/controllability-example2.png">
                                `,
                                answers: [
                                    "Yes, then the system is still controllable, because the supervisor still has two edges for the <code>push</code> event and that event is thus also still in the alphabet of the supervisor.",
                                    "Yes, then the system is still controllable, since the button plant specifies that between two pushes of the button always a release must happen, and therefore the supervisor does not disable any uncontrollable events of the plant.",
                                    "No, then the system is not controllable anymore, as the supervisor disables the <code>push</code> event in states where it is possible in the plant.",
                                    "No, then the system is not controllable anymore, because the modeler added these edges for a reason."
                                ],
                                correctAnswer: '3'
                            }
                        ]
                    </div>

                    <h2>Non-blockingness</h2>
                    <p>
                        In Module 2, you learned about <a href="../module2/reachability-deadlock-blocking-livelock.html#blocking-and-livelock">blocking</a> states.
                        Recall that a state is blocking if it is not marked and it is also not possible to reach a marked state from it by taking one or more transitions.
                        Marked states are stable states or safe havens.
                        For instance, for safety reasons, it must always be possible to turn off a machine.
                        And in a production system, if a product enters a system, it must always be able to leave the system again, after having been processed.
                        In general, once the system leaves a marked state, it can be seen as performing some task, and it must complete the task, before going back to a marked state.
                        The system must be able to progress to a stable state, rather than for instance getting stuck.
                    </p>
                    <p>
                        As another example, think for instance of a car.
                        Before you enter it, it is off and empty, which could be its marked state.
                        Let's say you want to go for a short trip.
                        You enter the car and you start it.
                        Only once you've reached your destination, do you want to turn off your car and exit it.
                        The car is then off and empty again, and back in its marked state.
                    </p>
                    <p>
                        It is thus important that in a controlled system all reachable states are non-blocking.
                        They are thus either themselves marked, or from each of them it is possible to reach a marked state.
                        When a synthesized supervisor is combined with the plant, the resulting controlled system is guaranteed to be non-blocking.
                        In other words, in a controlled system with a synthesized supervisor no reachable state is blocking.
                        It is up to the modeler to ensure proper marked states are defined, such that the stable states are appropriate for the system.
                    </p>

                    <h2>Quiz</h2>
                    <div class="quiz">
                        [
                            {
                                type: 'single-choice',
                                question: `
                                    Consider two locations, <code>A</code> and <code>B</code>.
                                    Location <code>A</code> is a deadlock location, is not initial and is not marked.
                                    Location <code>B</code> has one outgoing edge leading to location <code>A</code>.
                                    Are <code>A</code> and <code>B</code> blocking?
                                `,
                                answers: [
                                    "<code>A</code> is blocking because it has deadlock and is not marked. <code>B</code> is non-blocking because further behavior is possible (it has an outgoing edge).",
                                    "You cannot know whether <code>A</code> and <code>B</code> are blocking, because you need to know the rest of the automaton.",
                                    "<code>A</code> and <code>B</code> are both blocking: <code>A</code> is blocking because it has deadlock and is not marked, and <code>B</code> is then also blocking because its only outgoing edge leads to a blocking location.",
                                    "<code>A</code> is blocking because it has deadlock and is not marked. For <code>B</code> it depends on whether it is a marked location, which is not stated in the question."
                                ],
                                correctAnswer: '4'
                            },
                            {
                                type: 'single-choice',
                                question: `
                                    Consider again the car/motor example from earlier in this sub-module, where a button push turns on the motor and releasing the button turns it off.
                                    Is this system non-blocking?
                                `,
                                answers: [
                                    "Yes.",
                                    "No.",
                                    "It depends."
                                ],
                                correctAnswer: '1'
                            },
                            {
                                type: 'single-choice',
                                question: `
                                    Consider the following automaton.
                                    Is this a proper non-blocking plant, that does not need a supervisor to restrict any of its behavior to make it non-blocking?
                                    <img src="images/blocking-plant.png">
                                `,
                                answers: [
                                    "Yes, since the plant doesn't have any blocking behavior.",
                                    "No, since locations <code>6</code> and <code>7</code> are blocking.",
                                    "This can't be determined as it is unclear what the system represents."
                                ],
                                correctAnswer: '2'
                            },
                            {
                                type: 'single-choice',
                                question: `
                                    If we add the following supervisor to the plant of the previous question, is the controlled system then controllable and non-blocking?
                                    <img src="images/blocking-supervisor1.png">
                                `,
                                answers: [
                                    "Yes, since it removes the blocking behavior by disabling event <code>a</code> in location <code>5</code>.",
                                    "No, since it disables uncontrollable event <code>a</code>, which means it is not controllable.",
                                    "This can't be determined, as the system that the automaton represents is not known."
                                ],
                                correctAnswer: '2'
                            }
                        ]
                    </div>

                    <h2>Controllability revisited</h2>
                    <p>
                        In the quiz just now, you saw that it is not always sufficient for a supervisor to simply prevent reaching non-blocking states.
                        The supervisor prevents reaching locations <code>6</code> and <code>7</code> of the plant.
                        But, it does so by disabling event <code>a</code> in location <code>5</code>.
                        Since in the controlled system this location is reachable, and the plant does allow event <code>a</code> then, the controlled system is not controllable.
                    </p>
                    <p>
                        So, what can be done here?
                        Preventing the system from reaching locations <code>6</code> and <code>7</code> of the plant is required to satisfy non-blockingness.
                        This makes location <code>5</code> a so-called <em>bad</em> location.
                        In general, non-blocking states are bad, because they are not marked and from them no marked state can be reached.
                        But, states from which a transition for an uncontrollable event leads to a bad state, are in turn also bad.
                        This means that location <code>5</code> is a bad location in this case.
                        In a way, the badness of location <code>6</code> is pushed backwards through the dashed arrow to location <code>5</code>.
                        Since there are no dashed arrows to location <code>5</code>, no further backwards propagation is needed.
                    </p>
                    <p>
                        To ensure controllability, supervisor synthesis computes all this automatically.
                        It prevents reaching blocking states, but also prevents reaching any states from where via uncontrollable events such states can be reached.
                        It thus prevents all such bad states from being reached.
                    </p>

                    <h2>Maximal permissiveness</h2>
                    <p>
                        The final guarantee of synthesis that we'll look at here, is <em>maximal permissiveness</em>.
                        Consider the following three supervisors, that remove all bad states from the example system that we just looked at:
                    </p>
                    <img src="images/maximal-permissiveness.png">
                    <p>
                        These three supervisors each ensure that the controlled system is both non-blocking and controllable.
                        Still, they don't all allow the same behavior in the controlled system.
                        In fact, it is often the case that multiple supervisors exist that make the controlled system non-blocking and controllable.
                    </p>
                    <p>
                        This poses the question which of the multiple possible supervisors we prefer.
                        There could be many reasons for preferring one supervisor over another.
                        The reasons may include aspects that are not modeled, such as performance, cost, energy consumption or wear and tear.
                        Supervisor synthesis opts to not put any restrictions on the system, unless they are required to satisfy one of its guarantees.
                        For instance, it will remove all states that are bad due to being blocking or violating the controllability guarantee.
                        The maximal-permissiveness guarantee means that synthesized supervisors only restrict the behavior of a system as much is needed to satisfy the other guarantees.
                        They do not unnecessarily restrict any more behavior, and are thus <em>minimally restrictive</em>.
                        The guarantee is therefore also called <em>minimal-restrictiveness</em>.
                    </p>
                    <p>
                        After synthesis, other means can then be used to further restrict the behavior.
                        For instance, consider a system where two machines process products.
                        A supervisor may decide to always use the first machine, always use the second machine, or to use both machines.
                        Since a synthesized supervisor is maximally permissive, it allows all these options.
                        To prevent not using one of the machines, and also prevent the one machine that is used from quickly wearing out, one could alternate products between the machines.
                        Depending on the criteria, it may be possible to include these decisions already during synthesis, or the choice can be made afterwards using different techniques.
                        Such other techniques are outside the scope of this course.
                    </p>
                    <p>
                        Let's go back to the three supervisors in the figure above.
                        The middle and right supervisors lacks some behavior that the left supervisor has.
                        For instance, the right supervisor lacks the bottom location and its incoming and outgoing edge.
                        The left supervisor has all the behavior that the middle and right ones have, and more.
                        This is the maximally-permissive supervisor for the plant of this example.
                        It is identical to plant, but with bad locations <code>5</code>, <code>6</code> and <code>7</code>, as well as all their incoming and outgoing edges, removed.
                        Besides that, nothing else is removed, making this is the maximally-permissive supervisor.
                    </p>

                    <h2>Quiz</h2>
                    <div class="quiz">
                        [
                            {
                                type: 'single-choice',
                                question: `
                                    Consider again the three supervisors above.
                                    Why is the left supervisor maximally permissive and the middle one not?
                                    They look almost the same.
                                `,
                                answers: [
                                    "The middle supervisor unnecessarily disables event <code>d</code> in plant location <code>1</code>, while the left supervisor does not unnecessarily restrict any behavior of the plant.",
                                    "The left supervisor unnecessarily disables event <code>d</code> in plant location <code>1</code>, while the middle supervisor does not unnecessarily restrict any behavior of the plant.",
                                    "Maximally permissive simply means maximal in size, and because the left supervisor is bigger than the middle one, the left supervisor is maximally permissive."
                                ],
                                correctAnswer: '1'
                            },
                            {
                                type: 'multiple-choice',
                                question: `
                                    Consider again the <a href="../module2/reachability-deadlock-blocking-livelock.html#deadlock">example used to explain deadlock</a>, from a previous module.
                                    If we consider that automaton the plant model, which statements are then correct about the following supervisor?
                                    <img src="images/deadlock-supervisor.png">
                                `,
                                answers: [
                                    "It removes non-marked deadlock location <code>3</code>, making the system non-blocking.",
                                    "It is controllable, since no uncontrollable events are defined at all.",
                                    "It does not restrict any more behavior of the plant than is strictly needed, and is therefore maximally permissive.",
                                ],
                                correctAnswer: '1, 2, 3'
                            },
                            {
                                type: 'multiple-choice',
                                question: `
                                    Consider again the <a href="../module2/reachability-deadlock-blocking-livelock.html#blocking-and-livelock">example automaton used to explain blocking</a>, from a previous module, where location <code>2</code> is marked.
                                    If we consider that automaton the plant model, which statements are then correct about the following supervisor?
                                    <img src="images/blocking-supervisor2.png">
                                `,
                                answers: [
                                    "It is non-blocking.",
                                    "It is controllable, since no uncontrollable events are defined at all.",
                                    "It does not restrict any more behavior of the plant than is strictly needed, and is therefore maximally permissive.",
                                ],
                                correctAnswer: '1, 2, 3'
                            },
                            {
                                type: 'single-choice',
                                question: "Does the plant automaton considered in the previous question need a supervisor?",
                                answers: [
                                    "Yes, the uncontrolled system always needs a supervisor.",
                                    "No, the automaton is by itself already a proper controlled system."
                                ],
                                correctAnswer: '2'
                            }
                        ]
                    </div>

                    <h2>Properties of the supervisor and the controlled system</h2>
                    <p>
                        If a controlled system consisting of a plant and a supervisor is non-blocking, controllable and maximally permissive, then the supervisor that controls the plant is also non-blocking, controllable and maximally permissive.
                        The inverse is however not always true in regard to non-blockingness.
                        That is, if the plant and supervisor by themselves are both non-blocking, then their combination may be blocking and thus the controlled system is then blocking.
                    </p>

                    <h2>Quiz</h2>
                    <div class="quiz">
                        [
                            {
                                type: 'multiple-choice',
                                question: `
                                    Consider the following plant (left) and supervisor (right).
                                    Which of these statements are correct?
                                    <img src="images/supervisor-vs-controlled-system1.png">
                                `,
                                answers: [
                                    "The plant is non-blocking.",
                                    "The supervisor is non-blocking.",
                                    "The controlled system is non-blocking.",
                                ],
                                correctAnswer: '1, 2, 3'
                            },
                            {
                                type: 'multiple-choice',
                                question: `
                                    Consider the following plant (left) and supervisor (right).
                                    Which of these statements are correct?
                                    <img src="images/supervisor-vs-controlled-system2.png">
                                `,
                                answers: [
                                    "The plant is non-blocking.",
                                    "The supervisor is non-blocking.",
                                    "The controlled system is non-blocking.",
                                ],
                                correctAnswer: '1, 2'
                            },
                            {
                                type: 'multiple-choice',
                                question: `
                                    Consider the following plant (left) and supervisor (right).
                                    Which of these statements are correct?
                                    <img src="images/supervisor-vs-controlled-system3.png">
                                `,
                                answers: [
                                    "The plant is non-blocking.",
                                    "The supervisor is non-blocking.",
                                    "The controlled system is non-blocking.",
                                ],
                                correctAnswer: '1, 2, 3'
                            }
                        ]
                    </div>

                    <div class="course-navigation-footer">
                        <div class="course-navigation-prev"><a href="supervisory-control-loop.html">Go back to Module 3.1</a></div>
                        <div class="course-navigation-separator">|</div>
                        <div class="course-navigation-next"><a href="supervisory-controller-synthesis.html">Proceed to Module 3.3</a></div>
                    </div>

                </div>
            </div>
        </div>

        <!-- Footer -->
        <div class="container" id="footer">
            <footer class="pt-3 mt-4">
                <ul class="nav justify-content-center border-top pb-1 mb-1">
                    <li class="nav-item"><a class="nav-link px-2 text-muted" href="https://eclipse.org">Eclipse Home</a></li>
                    <li class="nav-link disabled text-muted">|</li>
                    <li class="nav-item"><a class="nav-link px-2 text-muted" href="https://eclipse.org/legal/privacy.php">Eclipse Privacy Policy</a></li>
                    <li class="nav-link disabled text-muted">|</li>
                    <li class="nav-item"><a class="nav-link px-2 text-muted" href="https://eclipse.org/legal/termsofuse.php">Eclipse Terms of Use</a></li>
                    <li class="nav-link disabled text-muted">|</li>
                    <li class="nav-item"><a class="nav-link px-2 text-muted" href="https://eclipse.org/legal/copyright.php">Eclipse Copyright Agent</a></li>
                    <li class="nav-link disabled text-muted">|</li>
                    <li class="nav-item"><a class="nav-link px-2 text-muted" href="https://eclipse.org/legal">Eclipse Legal</a></li>
                    <li class="nav-link disabled text-muted">|</li>
                    <li class="nav-item"><a class="nav-link px-2 text-muted" href="https://eclipse.dev/escet/legal.html">Eclipse ESCET Legal</a></li>
                </ul>
                <p class="text-center text-muted">Copyright © 2010, 2025 Contributors to the Eclipse Foundation</p>
            </footer>
        </div>

    </body>
</html>
